unit devsel;

interface

uses
  Forms, Controls, ExtCtrls, Classes, ComCtrls, StdCtrls, BFDiscovery,
  BFBaseComponent, BFIrDADiscovery, Buttons;

type
  TfmDevSel = class(TForm)
    PageControl: TPageControl;
    Panel: TPanel;
    tsBluetooth: TTabSheet;
    tsIrDA: TTabSheet;
    tsCOMPort: TTabSheet;
    btOK: TButton;
    btCancel: TButton;
    BFIrDADiscovery: TBFIrDADiscovery;
    BFDiscovery: TBFDiscovery;
    laBluetoothAddress: TLabel;
    edBluetoothAddress: TEdit;
    sbSelectBluetoothDevice: TSpeedButton;
    laIrDAAddress: TLabel;
    edIrDAAddress: TEdit;
    sbSelectIrDADevice: TSpeedButton;
    laPort: TLabel;
    edPort: TEdit;
    laInitString: TLabel;
    edInitString: TEdit;
    procedure sbSelectBluetoothDeviceClick(Sender: TObject);
    procedure sbSelectIrDADeviceClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  end;

implementation

{$R *.dfm}

procedure TfmDevSel.sbSelectBluetoothDeviceClick(Sender: TObject);
var
  Dev: TBFDevice;
begin
  Dev := BFDiscovery.SelectDevice(True);

  if Assigned(Dev) then begin
    edBluetoothAddress.Text := Dev.Address;
    Dev.Free;
  end;
end;

procedure TfmDevSel.sbSelectIrDADeviceClick(Sender: TObject);
var
  Dev: TBFIrDADevice;
begin
  Dev := BFIrDADiscovery.SelectDevice;

  if Assigned(Dev) then begin
    edIrDAAddress.Text := Dev.Address;
    Dev.Free;
  end;
end;

procedure TfmDevSel.FormCreate(Sender: TObject);
begin
  PageControl.ActivePageIndex := 0;
end;

end.
