unit main;

interface

uses
  Forms, BFAuthenticator, Classes, BFBaseComponent, BFServer, Controls,
  StdCtrls, BFAPI, ComCtrls;

type
  TfmMain = class(TForm)
    BFAuthenticator: TBFAuthenticator;
    Label1: TLabel;
    BFObjectPushServer: TBFObjectPushServer;
    ProgressBar1: TProgressBar;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure BFObjectPushServerConnect(Sender: TObject);
    procedure BFObjectPushServerDisconnect(Sender: TObject);
    procedure BFObjectPushServerObject(Sender: TObject; ObjectName: String; AObject: TBFByteArray);
    procedure Button1Click(Sender: TObject);
    procedure BFObjectPushServerProgress(Sender: TObject;
      ObjectName: String; Position, Size: Cardinal; var Abort: Boolean);
  private
    FAbort: Boolean;
  end;

var
  fmMain: TfmMain = nil;

implementation

{$R *.dfm}

procedure TfmMain.FormCreate(Sender: TObject);
begin
  Label1.Caption := 'Waiting for connection...';
  BFObjectPushServer.Open;
  FAbort := False;
end;

procedure TfmMain.BFObjectPushServerConnect(Sender: TObject);
begin
  Label1.Caption := 'Client ' + BFObjectPushServer.RemoteName + ' connected';
  FAbort := False;
  Button1.Enabled := True;
end;

procedure TfmMain.BFObjectPushServerDisconnect(Sender: TObject);
begin
  Label1.Caption := 'Waiting for connection...';
  FAbort := False;
  Button1.Enabled := False;
end;

procedure TfmMain.BFObjectPushServerObject(Sender: TObject; ObjectName: String; AObject: TBFByteArray);
var
  Loop: Integer;
  AFile: file of Byte;
begin
  Label1.Caption := 'Object received';

  AssignFile(AFile, ObjectName);
  Rewrite(AFile);

  for Loop := 0 to Length(AObject) - 1 do Write(AFile, AObject[Loop]);

  CloseFile(AFile);
end;

procedure TfmMain.Button1Click(Sender: TObject);
begin
  FAbort := True;
end;

procedure TfmMain.BFObjectPushServerProgress(Sender: TObject;
  ObjectName: String; Position, Size: Cardinal; var Abort: Boolean);
begin
  ProgressBar1.Max := Size;
  ProgressBar1.Position := Position;
  Update;
  Application.ProcessMessages;
  Abort := FAbort;
end;

end.
